#define PIN_SURFACE
#include "default.hlsl"

Surface surfaceShader(SurfaceInput IN, float fade)
{
	float3 normal = 2 * tex2D(NormalMap, IN.Uv * 1.2).xyz - 1;

    float3 dColor = IN.Color.rgb;

	float tNormSum = 0.9+dot(0.1, normal);
	dColor *= tNormSum;

	normal.xy *= 0.3 * fade;

    Surface surface = (Surface)0;
    surface.albedo = lerp(IN.Color, dColor, fade);
    surface.normal = normal;
    surface.specular = 0.9;
    surface.gloss = 25;

	return surface;
}
