#define PIN_SURFACE
#include "default.hlsl"

Surface surfaceShader(SurfaceInput IN, float fade)
{
	const float NoiseScale = 7;

	float3 normal = tex2D(NormalMap, IN.Uv.xy * 0.1).xyz - 0.5;

	float3 shiftPos = IN.SurfaceCoord.xyz;

    float3 noiseval = tex3D(NoiseMap,shiftPos.xyz/NoiseScale*0.04).xyz;
	float3 noiseval2 = tex3D(NoiseMap,shiftPos.xyz/NoiseScale*0.3).xyz + 0.2;
	noiseval *= noiseval2;

	float3 dColor = IN.Color.xyz + (noiseval*0.4 - 0.08);

	float tNormSum = 0.9+dot(0.4, normal);
	dColor *= tNormSum;

    normal.xy *= fade;
	normal.z = 2;

    Surface surface = (Surface)0;
    surface.albedo = lerp(IN.Color.rgb, dColor, fade);
    surface.normal = normal;
    surface.specular = 0.1;
    surface.gloss = 40;

	return surface;
}	
	
